var BLOCKS = {
    '(': ')',
    '[': ']',
};
var QUOTES = {
    '"': '"',
    "'": "'",
};
var FINALIZERS = {
    ')': '(',
    ']': '[',
};
var SPLIT_ON = {
    ',': ',',
};
export var splitSelector = function (selector) {
    var selectors = [];
    var stack = [];
    var joiners = [];
    var currentSelector = '';
    for (var i = 0; i < selector.length; i += 1) {
        var char = selector[i];
        if (BLOCKS[char] || QUOTES[char]) {
            if (stack.length === 0) {
                stack.push(char);
            }
            else {
                var lastBrace = stack[stack.length - 1];
                if (QUOTES[lastBrace]) {
                    if (char === lastBrace) {
                        stack.pop();
                    }
                }
                else {
                    stack.push(char);
                }
            }
            currentSelector += char;
        }
        else if (FINALIZERS.hasOwnProperty(char)) {
            var lastBrace = stack[stack.length - 1];
            var matchingOpener = FINALIZERS[char];
            if (lastBrace === matchingOpener) {
                stack.pop();
            }
            currentSelector += char;
        }
        else if (SPLIT_ON[char]) {
            if (!stack.length) {
                var lastJoiner = joiners[joiners.length - 1];
                if (lastJoiner === ' ' && currentSelector.length <= 0) {
                    joiners[joiners.length - 1] = char;
                }
                else if (currentSelector.length <= 0) {
                }
                else {
                    var newLength = selectors.push(currentSelector);
                    joiners[newLength - 1] = char;
                    currentSelector = '';
                }
            }
            else {
                currentSelector += char;
            }
        }
        else {
            currentSelector += char;
        }
    }
    selectors.push(currentSelector);
    return selectors.map(function (selector) { return selector.trim(); }).filter(function (cssSelector) { return cssSelector.length > 0; });
};
