import { pruneSelector } from './operations/prune-selector';
import { assertIsReady } from './utils/async';
export const alterProjectStyles = (def, options) => {
    assertIsReady(def);
    return {
        ...def,
        ast: Object.keys(def.ast).reduce((acc, file) => {
            const astFile = def.ast[file];
            const shouldRemove = options.filter && !options.filter(file);
            if (shouldRemove) {
                return acc;
            }
            acc[file] = options.pruneSelector ? pruneSelector(astFile, options.pruneSelector) : astFile;
            return acc;
        }, {}),
    };
};
