const BLOCKS = {
    '(': ')',
    '[': ']',
};
const QUOTES = {
    '"': '"',
    "'": "'",
};
const FINALIZERS = {
    ')': '(',
    ']': '[',
};
const SPLIT_ON = {
    ',': ',',
};
export const splitSelector = (selector) => {
    const selectors = [];
    const stack = [];
    const joiners = [];
    let currentSelector = '';
    for (let i = 0; i < selector.length; i += 1) {
        const char = selector[i];
        if (BLOCKS[char] || QUOTES[char]) {
            if (stack.length === 0) {
                stack.push(char);
            }
            else {
                const lastBrace = stack[stack.length - 1];
                if (QUOTES[lastBrace]) {
                    if (char === lastBrace) {
                        stack.pop();
                    }
                }
                else {
                    stack.push(char);
                }
            }
            currentSelector += char;
        }
        else if (FINALIZERS.hasOwnProperty(char)) {
            const lastBrace = stack[stack.length - 1];
            const matchingOpener = FINALIZERS[char];
            if (lastBrace === matchingOpener) {
                stack.pop();
            }
            currentSelector += char;
        }
        else if (SPLIT_ON[char]) {
            if (!stack.length) {
                const lastJoiner = joiners[joiners.length - 1];
                if (lastJoiner === ' ' && currentSelector.length <= 0) {
                    joiners[joiners.length - 1] = char;
                }
                else if (currentSelector.length <= 0) {
                }
                else {
                    const newLength = selectors.push(currentSelector);
                    joiners[newLength - 1] = char;
                    currentSelector = '';
                }
            }
            else {
                currentSelector += char;
            }
        }
        else {
            currentSelector += char;
        }
    }
    selectors.push(currentSelector);
    return selectors.map((selector) => selector.trim()).filter((cssSelector) => cssSelector.length > 0);
};
