"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.memoizeOne = void 0;
function areInputsEqual(newInputs, lastInputs) {
    if (newInputs.length !== lastInputs.length) {
        return false;
    }
    for (var i = 0; i < newInputs.length; i++) {
        if (newInputs[i] !== lastInputs[i]) {
            return false;
        }
    }
    return true;
}
function memoizeOne(resultFn) {
    var lastArgs = [];
    var lastResult;
    var calledOnce = false;
    function memoized() {
        var newArgs = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            newArgs[_i] = arguments[_i];
        }
        if (calledOnce && areInputsEqual(newArgs, lastArgs)) {
            return lastResult;
        }
        lastResult = resultFn.apply(undefined, newArgs);
        calledOnce = true;
        lastArgs = newArgs;
        return lastResult;
    }
    return memoized;
}
exports.memoizeOne = memoizeOne;
